PRO vs_instrument_event, Event
  ;;
  widget_control, Event.Top, get_uval = InstrumentState, /No_Copy
  CASE Event.ID OF
      InstrumentState.InstrumentApply:BEGIN
          Widget_Control, InstrumentState.InstrumentFW, Get_Value = FilterWidth
          Widget_Control, InstrumentState.InstrumentStart, Get_Value = Starthr
          Widget_Control, InstrumentState.InstrumentEnd, Get_Value = Endhr
          Widget_Control, InstrumentState.InstrumentRot, Get_Value = Rot
          
          PseudoEvent = {INSTRUMENT_EVENT, $
                         ID:InstrumentState.InstrumentNotifyID[0], $
                         Top:InstrumentState.InstrumentNotifyID[1], $
                         Handler:0l, $
                         FilterW:FilterWidth, $
                         StartHr:StartHr, $
                         EndHr:EndHr, $
                         Rot:Rot $
                        }
          
          IF Widget_Info(InstrumentState.InstrumentNotifyID[0], /Valid_ID) THEN $
            widget_control, InstrumentState.InstrumentNotifyID[0], Send_Event = PseudoEvent
          widget_control, InstrumentState.InstrumentApply, sens = 0
      END
      InstrumentState.InstrumentDismiss:BEGIN
          Widget_Control, Event.Top, /Clear_Events, /Destroy
          return
      END
      ELSE:Widget_Control, InstrumentState.InstrumentApply, sens = 1
  ENDCASE 
  Widget_control, Event.Top, Set_Uval = InstrumentState, /No_Copy
END 

PRO vs_instrument, NotifyID, State
COMMON vs_block
  ;;
IF NOT vs_debug THEN on_error, 2
  IF NOT Xregistered('vs_instrument')  THEN BEGIN 
      ;;
      lab_apply = 'Apply'
      lab_dismiss = 'Dismiss'
      lab_end = 'End of Observation (Hrs aft. Meridian)'
      lab_filter = 'Filter width (Frac. of Lambda):'
      lab_rot = 'Artificial rotation angle on sky (degrees):'
      lab_start = 'Start of Observation (Hrs bef. Meridian)'
      lab_tit = 'VLTISim Instrument Setup'
      ;;
      Instrument = State.Instrument
      ;;
      ;;
      InstrumentBase = Widget_Base(tit = lab_tit, /col, /BAse_ALign_Right)
      InstrumentFilterBase = Widget_Base(InstrumentBase, col = 2, /Base_Align_Right)
      InstrumentFilterLab = Widget_Label(InstrumentFilterBase, val = lab_filter, font = vs_fonts[1])
      InstrumentFilterWidth = CW_Fslider($
                                          InstrumentFilterBase, $
                                          /edit, $
                                          /drag, $
                                          val = State.FilterW, $
                                          max = 1.0)
      InstrumentStartBase = Widget_Base(InstrumentBase, col = 2, /Base_Align_Right)
      InstrumentStartLab = Widget_Label(InstrumentStartBase, val = lab_start, font = vs_fonts[1])
      InstrumentStart = CW_Fslider($
                                    InstrumentStartBase, $
                                    /edit, $
                                    /drag, $
                                    val = State.StartHr, $
                                    min = -12.0, $
                                    max = 0.0)
     
      InstrumentEndBase = Widget_Base(InstrumentBase, col = 2, /Base_Align_Right)
      InstrumentEndLab = Widget_Label(InstrumentEndBase, val = lab_end, font = vs_fonts[1])
      InstrumentEnd = CW_Fslider($
                                  InstrumentEndBase, $
                                  /edit, $
                                  /drag, $
                                  val = State.EndHr, $
                                  max = 12.0 )
      InstrumentRotBase = Widget_Base(InstrumentBase, col = 2, /Base_Align_Right)
      InstrumentRotLab = Widget_Label(InstrumentRotBase, val = lab_rot, font = vs_fonts[1])
      InstrumentRot = CW_Fslider(InstrumentRotBase, $
                                 /edit, $
                                 /drag, $
                                 val = State.Rot, $
                                 min = -180., $
                                 max = 180)
      InstrumentControlBase = Widget_Base(InstrumentBase, col = 2, /Base_Align_Right)
      InstrumentApply = Widget_Button(InstrumentControlBase, val = lab_apply, font = vs_fonts[1])
      Widget_Control, InstrumentApply, sens=0
      InstrumentDismiss = Widget_Button(InstrumentControlBase, val = lab_dismiss, font = vs_fonts[1])
      InstrumentState = {IS, $
                         InstrumentFW:InstrumentFilterWidth, $
                         InstrumentStart:InstrumentStart, $
                         InstrumentEnd:InstrumentEnd, $
                         InstrumentRot:InstrumentRot, $
                         InstrumentApply:InstrumentApply, $
                         InstrumentDismiss:InstrumentDismiss, $
                         InstrumentNotifyID:NotifyID $
                        }
      
      widget_control, InstrumentBase, set_uval = InstrumentState, /No_Copy
      widget_control, InstrumentBase, /realize
      xmanager, 'vs_instrument', InstrumentBase, /no_block, Group_Leader = NotifyID[1]
  ENDIF 
END 
