; Help display routine for SimVLTI
; (C) 1999 M. Feldt <mfeldt@mpia-hd.mpg.de>

PRO update_vs_xhelp, Topic
COMMON vs_xhelp_block, HelpBase, HelpDismiss, HelpText, HelpList, TopicList
COMMON vs_block 

Filename = 'vs_help.hlp'
Topic = strupcase(Topic)
is_vms = !version.os eq 'vms'

text = ''
tmp = 'xxxx'
openr, unit, filepath(filename, root=vs_path), /get_lun, err = err
if (err eq 0) then BEGIN 
    REPEAT BEGIN
        readf, unit, tmp
        text = [[text], [tmp]]
    ENDREP UNTIL eof(unit) 
    free_lun, unit
    text = reform(text)
    StartPosition = where(text EQ '+++'+Topic)
    EndPosition =  where(text EQ '---'+Topic)
  
    IF StartPosition[0] NE -1 AND EndPosition[0] NE -1 THEN $
      text = text[StartPosition[0]+1:EndPosition[0]-1] $
    ELSE $
      text = 'No information found on '+name
    
ENDIF ELSE BEGIN
    text = 'Unable to open helpfile!'
ENDELSE

WIDGET_CONTROL, HelpText, Set_Value = string(text)
END

PRO vs_xhelp_event, Event
  COMMON vs_xhelp_block
  COMMON vs_block
  
  CASE Event.ID OF 
      HelpDismiss:Widget_Control, Event.Top, /Clear_Events, /Destroy
      HelpList:BEGIN
          EventName = tag_names(Event, /Structure_Name)
          IF EventName EQ 'PSEUDOXHELP' THEN $
            Topic = Event.Topic $
          ELSE $
            Topic = TopicList[Widget_Info(HelpList, /List_Select)]
          update_vs_xhelp, Topic
      END
  ENDCASE 
END 

pro VS_XHELP, name, Parent=Parent
  COMMON vs_block
  COMMON vs_xhelp_block

  IF NOT vs_debug THEN on_error, 2 ; On error, return to main level

  temp = size(NAME)
  if (temp(0) NE 0) then message, 'Argument must be scalar.'
  if (temp(1) NE 7) then message, 'Argument must be of type string.'

  if (!D.FLAGS and 65536) NE 65536 then message, $
    'ERROR - Current Device ' + !D.NAME + ' does not support widgets.'
  IF NOT xregistered('vs_xhelp') THEN BEGIN 
      ;;
      ;; get the list of available topics
      ;;
      Filename = 'vs_help.hlp'
      text = ''
      tmp = 'xxxx'
      openr, unit,filepath(filename, root=vs_path), /get_lun, err = err
      IF (err EQ 0) THEN BEGIN 
          REPEAT BEGIN
              readf, unit, tmp
              text = [[text], [tmp]]
          ENDREP UNTIL eof(unit) 
          free_lun, unit
      ENDIF ELSE message, 'Helpfile not found!'
      TopicIndexes = where(strmid(text[*], 0, 3) EQ '+++')
      NIndexes = N_Elements(TopicIndexes)
      TopicList = strarr(NIndexes)
      FOR i = 0, NIndexes-1 DO BEGIN
          TopicList[i] = strmid(text[TopicIndexes[i]], 3, $
                               strlen(text[TopicIndexes[i]])-3)
      ENDFOR 
      ;;
      ;; Now build the GUI
      ;;
      HelpBase = Widget_base(title = 'VLTISim XHELP', col = 2)
      HelpControl = Widget_base(HelpBase, /col, /frame)
      HelpText = Widget_Text(HelpBase, $
                             /scroll, $
                             xsize = 65, $
                             ysize = 35, $
                             font=vs_fonts[2])
      HelpLabel = Widget_Label(HelpControl, $
                               val = 'Available Topics:', $
                               font=vs_fonts[1])
      HelpList = Widget_List(HelpControl, $
                             val = TopicList, $
                             xsize = 15, $
                             ysize = 20, $
                             font=vs_fonts[2])
      HelpDismiss = Widget_Button(HelpControl, $
                                  val = 'Dismiss', $
                                  font=vs_fonts[1])
      
      Widget_Control, HelpBase, /Realize
      xmanager, 'vs_xhelp', HelpBase, /No_Block, Group_Leader=Parent
  ENDIF
  ;; Now update the display
  PseudoEvent = {PseudoXhelp, $
                 ID:HelpList, $
                 TOP:HelpBase, $
                 Handler:0l, $
                 Topic:name}
  Widget_control, HelpList, Send_Event = PseudoEvent
END   

